<template>
  <el-dialog
    append-to-body
    :title="textMap[dialogStatus]"
    :visible.sync="dialogFormVisible"
  >
    <el-form
      ref="dataForm"
      :rules="rules"
      :model="deviceForm"
      label-width="100px"
      label-well-code="right"
    >
      <el-row :gutter="20">
        <el-col :span="12">
          <el-form-item label="设备类型" prop="deviceType">
            <el-select
              v-model="deviceForm.deviceType"
              placeholder="请选择设备类型"
              clearable
              :disabled="dialogStatus === 'detail' ? true : false"
            >
              <el-option
                v-for="item in deviceTypeList"
                :key="item.value"
                :label="item.name"
                :value="item.value"
              />
            </el-select>
          </el-form-item>
        </el-col>
        <el-col :span="12">
          <el-form-item label="井类型" prop="wellType">
            <el-select
              v-model="deviceForm.wellType"
              clearable
              placeholder="请选择支持井类型"
              :disabled="dialogStatus === 'detail' ? true : false"
            >
              <el-option
                v-for="item in wellTypeList"
                :key="item.value"
                :label="item.label"
                :value="item.value"
              />
            </el-select>
          </el-form-item>
        </el-col>
      </el-row>
      <el-row :gutter="20">
        <el-col :span="12">
          <el-form-item label="经度" prop="lng">
            <el-input
              v-model="deviceForm.lng"
              clearable
              placeholder="请输入经度"
              :disabled="dialogStatus === 'detail' ? true : false"
            />
          </el-form-item>
        </el-col>
        <el-col :span="12">
          <el-form-item label="纬度" prop="lat">
            <el-input
              v-model="deviceForm.lat"
              clearable
              placeholder="请输入纬度"
              :disabled="dialogStatus === 'detail' ? true : false"
            />
          </el-form-item>
        </el-col>
      </el-row>
      <el-row v-show="dialogStatus === 'detail' ? true : false" :gutter="20">
        <el-col :span="12">
          <el-form-item label="组织id" prop="deptid">
            <el-input
              v-model="deviceForm.deptid"
              clearable
              disabled
              placeholder="请输入组织id"
            />
          </el-form-item>
        </el-col>
      </el-row>
    </el-form>
    <div
      v-show="dialogStatus === 'detail' ? false : true"
      slot="footer"
      class="dialog-footer"
    >
      <el-button type="primary" @click="saveData">
        保存
      </el-button>
      <el-button @click="dialogFormVisible = false">
        取消
      </el-button>
    </div>
  </el-dialog>
</template>

<script>
import { getDevice, updateDept, addDept } from '@/api/systemConfig/deptPermission'
export default {
  name: 'EditDeptPermission',
  data() {
    return {
      dialogFormVisible: false, // 对话框显示隐藏
      deviceTypeList: [], // 设备类型
      dialogStatus: '', // 对话框类型：create,update,detail
      // 对话框标题
      textMap: {
        update: '编辑',
        create: '新增',
        detail: '详情'
      },
      // 支持井类型
      wellTypeList: [
        {
          label: '井类型一',
          value: '1'
        },
        {
          label: '井类型二',
          value: '2'
        }
      ],
      // 表单内容
      deviceForm: {
        deptid: '',
        wellType: '',
        deviceType: '',
        lng: '',
        lat: ''
      },
      // 表单校验规则
      rules: {
        deptid: [{ required: true, message: '组织id不能为空', trigger: ['blur', 'change'] }],
        wellType: [{ required: true, message: '支持井类型必选', trigger: ['blur', 'change'] }],
        deviceType: [{ required: true, message: '支持设备类型必选', trigger: ['blur', 'change'] }],
        lng: [{ required: true, message: '经度不能为空', trigger: ['blur', 'change'] }],
        lat: [{ required: true, message: '纬度不能为空', trigger: ['blur', 'change'] }]
      }
    }
  },
  created() {
    this.fetchDeviceType()
  },
  methods: {
    // 获取设备类型
    fetchDeviceType() {
      getDevice().then(response => {
        this.deviceTypeList = response.data
      })
    },
    // 重置表单
    resetForm() {
      this.deviceForm = {
        deptid: '',
        wellType: '',
        deviceType: '',
        lng: '',
        lat: ''
      }
    },
    // 父子组件通信
    initDialog(dialogStatus, row = null) {
      this.dialogFormVisible = true
      this.dialogStatus = dialogStatus
      if (this.dialogStatus === 'create') {
        this.resetForm()
        this.$nextTick(() => {
          this.$refs['dataForm'].clearValidate()
        })
      } else if (this.dialogStatus === 'update' || this.dialogStatus === 'detail') {
        this.deviceForm = {
          deptid: row.deptid,
          wellType: row.wellType,
          deviceType: row.deviceType,
          lng: row.lng,
          lat: row.lat
        }
      }
    },
    // 保存数据
    saveData() {
      if (this.dialogStatus === 'update') {
        this.updateData()
      } else if (this.dialogStatus === 'create') {
        this.createData()
      }
    },
    // 修改数据
    updateData() {
      this.$refs['dataForm'].validate((valid) => {
        if (valid) {
          updateDept(this.deviceForm).then(response => {
            if (response.code === 200) {
              this.$message.success('修改成功')
              this.$emit('watchChild')
              this.dialogFormVisible = false
            }
          })
        }
      })
    },
    // 新增数据
    createData: function() {
      this.$refs['dataForm'].validate((valid) => {
        console.log(this.deviceForm)
        if (valid) {
          addDept(this.deviceForm).then(response => {
            if (response.code === 200) {
              this.$confirm('新增成功，是否继续新增?', '提示', {
                confirmButtonText: '是',
                cancelButtonText: '否',
                type: 'info'
              }).then(() => {
                this.resetForm()
                this.$nextTick(() => {
                  this.$refs['dataForm'].clearValidate()
                })
              }).catch(() => {
                this.$emit('watchChild') // 刷新父组件数据列表
                this.dialogFormVisible = false
              })
            }
          })
        }
      })
    }
  }
}
</script>

<style rel="stylesheet/scss" lang="scss" scoped>
  .el-select{
    width: 100%;
  }
</style>
